`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 27.03.2023 21:14:57
// Design Name: 
// Module Name: top
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top(clk, reset, a, b, carry_in_initial, 
                carry_out, sum, done);
input clk, reset; 
input [63:0] a, b; 
input carry_in_initial;

output carry_out;
output [63:0] sum; 
output done;


wire rst_a, shift_a, rst_b, shift_b, carry_sel;
wire enable_sum, rst_count, inc_count;
wire counter_is7;


dp_mpadder DP(clk, 
                  a, b, carry_in_initial, // input data variables
                  rst_a, shift_a, rst_b, shift_b, carry_sel, // Input control sig. 
                  enable_sum, rst_count, inc_count,          // Input control sig.
                  counter_is7,      // Output status signal
                  carry_out, sum    // Output data variables       
               );

FSM_controller Cntrl(clk, reset, 
           rst_a, shift_a, rst_b, shift_b, carry_sel, // Output control sig. 
           enable_sum, rst_count, inc_count,   // Output control sig.
           counter_is7,      // Input status signal 
           done 
    );
    
endmodule
